Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.sql
Class QSqlDatabase

    java.lang.Object
      com.trolltech.qt.QSignalEmitter
          com.trolltech.qt.QtJambiObject
              com.trolltech.qt.sql.QSqlDatabase

All Implemented Interfaces:
  QtJambiInterface, java.lang.Cloneable

    public class QSqlDatabase

extends QtJambiObject
implements java.lang.Cloneable

The `QSqlDatabase` class represents a connection to a database. The `QSqlDatabase` class provides an abstract interface for accessing database backends. It relies on database-specific `QSqlDriver`s to actually access and manipulate data.

The following code shows how to initialize a connection:

            QSqlDatabase db = QSqlDatabase.addDatabase("QPSQL");
            db.setHostName("apollo");
            db.setDatabaseName("customdb");
            db.setUserName("mojito");
            db.setPassword("J0a1m8");
            boolean ok = db.open();

Once a `QSqlDatabase` object has been created you can set the connection parameters with `setDatabaseName()`, `setUserName()`, `setPassword()`, `setHostName()`, `setPort()`, and `setConnectOptions()`. Once the parameters have been set up you can call `open()` to open the connection.

The connection defined above is a nameless connection. It is the default connection and can be accessed using `database()` later on:

            QSqlDatabase db = QSqlDatabase.database();

To make programming more convenient, `QSqlDatabase` is a value class. Any changes done to a database connection through one `QSqlDatabase` object will affect other `QSqlDatabase` objects representing the same connection. Call `cloneDatabase()` if you want to create an independent database connection based on an existing one.

If you need multiple database connections simultaneously, specify an arbitrary name to `addDatabase()` and `database()`. Call `removeDatabase()` to remove connections. `QSqlDatabase` will output a warning if you try to remove a connection referenced by other `QSqlDatabase` objects. Use `contains()` to see if a given connection name is in the list of connections.

Once a connection is established you can see what tables the database offers with `tables()`, find the primary index for a table with `primaryIndex()`, get meta-information about a table's fields (e.g., their names) with `record()`, and execute a query with `exec()`.

If transactions are supported, you can use `transaction()` to start a transaction, and then `commit()` or `rollback()` to complete it. You can find out whether transactions are supported using `QSqlDriver::hasFeature()`. When using transactions you must start the transaction before you create your query.

If an error occurred, it is given by `lastError()`.

The names of the underlying SQL drivers are available from `drivers()`; you can check for a particular driver with `isDriverAvailable()`. If you have created your own custom driver, you can register it with `registerSqlDriver()`.

See also:
  `QSqlDriver`, `QSqlQuery`, QtSql Module, and Threads and the SQL Module.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Constructor Summary
`` | `QSqlDatabase()` Creates an empty, invalid `QSqlDatabase` object.
`` | `QSqlDatabase(QSqlDatabase other)` Creates a copy of `other`.
`protected` | `QSqlDatabase(QSqlDriver driver)` Creates a database connection using the given `driver`.
`protected` | `QSqlDatabase(java.lang.String type)` Creates a `QSqlDatabase` connection that uses the driver referred to by `type`.

Method Summary
`static QSqlDatabase` | `addDatabase(QSqlDriver driver)` This function is useful if you need to set up the database connection and instantiate the driver yourself.
`static QSqlDatabase` | `addDatabase(QSqlDriver driver, java.lang.String connectionName)` This function is useful if you need to set up the database connection and instantiate the driver yourself.
`static QSqlDatabase` | `addDatabase(java.lang.String type)` Adds a database to the list of database connections using the driver `type` and the connection name `connectionName`.
`static QSqlDatabase` | `addDatabase(java.lang.String type, java.lang.String connectionName)` Adds a database to the list of database connections using the driver `type` and the connection name `connectionName`.
`QSqlDatabase` | `clone()` This method is reimplemented for internal reasons
`static QSqlDatabase` | `cloneDatabase(QSqlDatabase other, java.lang.String connectionName)` Clones the database connection `other` and and stores it as `connectionName`.
`void` | `close()` Closes the database connection, freeing any resources acquired, and invalidating any existing `QSqlQuery` objects that are used with the database.
`boolean` | `commit()` Commits a transaction to the database if the driver supports transactions and a `transaction()` has been started.
`java.lang.String` | `connectionName()` Returns the connection's name; it may be empty.
`static java.util.List` | `connectionNames()` Returns a list containing the names of all connections.
`java.lang.String` | `connectOptions()` Returns the connection options string used for this connection.
`static boolean` | `contains()` Returns true if the list of database connections contains `connectionName`; otherwise returns false.
`static boolean` | `contains(java.lang.String connectionName)` Returns true if the list of database connections contains `connectionName`; otherwise returns false.
`static QSqlDatabase` | `database()` Returns the database connection called `connectionName`.
`static QSqlDatabase` | `database(java.lang.String connectionName)` Returns the database connection called `connectionName`.
`static QSqlDatabase` | `database(java.lang.String connectionName, boolean open)` Returns the database connection called `connectionName`.
`java.lang.String` | `databaseName()` Returns the connection's database name; it may be empty.
`static java.lang.String` | `defaultConnection()` Returns this QSqlDatabase's default connection.
`QSqlDriver` | `driver()` Returns the database driver used to access the database connection.
`java.lang.String` | `driverName()` Returns the connection's driver name.
`static java.util.List` | `drivers()` Returns a list of all the available database drivers.
`QSqlQuery` | `exec()` Executes a SQL statement on the database and returns a `QSqlQuery` object.
`QSqlQuery` | `exec(java.lang.String query)` Executes a SQL statement on the database and returns a `QSqlQuery` object.
`static QSqlDatabase` | `fromNativePointer(QNativePointer nativePointer)` This method returns the QSqlDatabase instance pointed to by `nativePointer`.
`java.lang.String` | `hostName()` Returns the connection's host name; it may be empty.
`static boolean` | `isDriverAvailable(java.lang.String name)` Returns true if a driver called `name` is available; otherwise returns false.
`boolean` | `isOpen()` Returns true if the database connection is currently open; otherwise returns false.
`boolean` | `isOpenError()` Returns true if there was an error opening the database connection; otherwise returns false.
`boolean` | `isValid()` Returns true if the `QSqlDatabase` has a valid driver.
`QSqlError` | `lastError()` Returns information about the last error that occurred on the database.
`static QNativePointer` | `nativePointerArray(QSqlDatabase[] array)` This function returns a QNativePointer that is pointing to the specified QSqlDatabase array.
`boolean` | `open()` Opens the database connection using the current connection values.
`boolean` | `open(java.lang.String user, java.lang.String password)` Opens the database connection using the given `user` name and `password`.
`java.lang.String` | `password()` Returns the connection's password.
`int` | `port()` Returns the connection's port number.
`QSqlIndex` | `primaryIndex(java.lang.String tablename)` Returns the primary index for table `tablename`.
`QSqlRecord` | `record(java.lang.String tablename)` Returns a `QSqlRecord` populated with the names of all the fields in the table (or view) called `tablename`.
`static void` | `registerSqlDriver(java.lang.String name, QSqlDriverCreatorBase creator)` This function registers a new SQL driver called `name`, within the SQL framework.
`static void` | `removeDatabase(java.lang.String connectionName)` Removes the database connection `connectionName` from the list of database connections.
`boolean` | `rollback()` Rolls a transaction back on the database if the driver supports transactions and a `transaction()` has been started.
`void` | `setConnectOptions()` Sets database-specific `options`.
`void` | `setConnectOptions(java.lang.String options)` Sets database-specific `options`.
`void` | `setDatabaseName(java.lang.String name)` Sets the connection's name to `name`.
`void` | `setHostName(java.lang.String host)` Sets the connection's host name to `host`.
`void` | `setPassword(java.lang.String password)` Sets the connection's password to `password`.
`void` | `setPort(int p)` Sets the connection's port number to `port`.
`void` | `setUserName(java.lang.String name)` Sets the connection's user name to `name`.
`java.util.List` | `tables()` This is an overloaded method provided for convenience.
`java.util.List` | `tables(QSql.TableType type)` Returns a list of the database's tables, system tables and views, as specified by the parameter `type`.
`java.lang.String` | `toString()` Returns a string representation of the `this QSqlDatabase`.
`boolean` | `transaction()` Begins a transaction on the database if the driver supports transactions.
`java.lang.String` | `userName()` Returns the connection's user name; it may be empty.

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class java.lang.Object
`getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QSqlDatabase

    public QSqlDatabase()

  Creates an empty, invalid `QSqlDatabase` object. Use `addDatabase()`, `removeDatabase()`, and `database()` to get valid `QSqlDatabase` objects.

### QSqlDatabase

    protected QSqlDatabase(QSqlDriver driver)

  Creates a database connection using the given `driver`.

### QSqlDatabase

    public QSqlDatabase(QSqlDatabase other)

  Creates a copy of `other`.

### QSqlDatabase

    protected QSqlDatabase(java.lang.String type)

  Creates a `QSqlDatabase` connection that uses the driver referred to by `type`. If the `type` is not recognized, the database connection will have no functionality.

  The currently available driver types are:

  Driver Type | Description
  --- | ---
  QDB2 | IBM DB2
  QIBASE | Borland InterBase Driver
  QMYSQL | MySQL Driver
  QOCI | Oracle Call Interface Driver
  QODBC | ODBC Driver (includes Microsoft SQL Server)
  QPSQL | PostgreSQL Driver
  QSQLITE | SQLite version 3 or above
  QSQLITE2 | SQLite version 2
  QTDS | Sybase Adaptive Server

  Additional third party drivers, including your own custom drivers, can be loaded dynamically.

See also:
  SQL Database Drivers, `registerSqlDriver()`, and `drivers()`.

Method Detail

### close

    public final void close()

  Closes the database connection, freeing any resources acquired, and invalidating any existing `QSqlQuery` objects that are used with the database.

  This will also affect copies of this `QSqlDatabase` object.

See also:
  `removeDatabase()`.

### commit

    public final boolean commit()

  Commits a transaction to the database if the driver supports transactions and a `transaction()` has been started. Returns true if the operation succeeded; otherwise returns false.

  Note that on some databases, this function will not work if there is an active `QSqlQuery` on the database. Use the `lastError()` function to retrieve database-specific error data about the error that occurred.

See also:
  `QSqlDriver::hasFeature()`, and `rollback()`.

### connectOptions

    public final java.lang.String connectOptions()

  Returns the connection options string used for this connection. The string may be empty.

See also:
  `setConnectOptions()`.

### connectionName

    public final java.lang.String connectionName()

  Returns the connection's name; it may be empty.

See also:
  `addDatabase()`.

### databaseName

    public final java.lang.String databaseName()

  Returns the connection's database name; it may be empty.

See also:
  `setDatabaseName()`.

### driver

    public final QSqlDriver driver()

  Returns the database driver used to access the database connection.

See also:
  `addDatabase()`, and `drivers()`.

### driverName

    public final java.lang.String driverName()

  Returns the connection's driver name.

See also:
  `addDatabase()`, and `driver()`.

### exec

    public final QSqlQuery exec()

  Executes a SQL statement on the database and returns a `QSqlQuery` object. Use `lastError()` to retrieve error information. If `query` is empty, an empty, invalid query is returned and `lastError()` is not affected.

See also:
  `QSqlQuery`, and `lastError()`.

### exec

    public final QSqlQuery exec(java.lang.String query)

  Executes a SQL statement on the database and returns a `QSqlQuery` object. Use `lastError()` to retrieve error information. If `query` is empty, an empty, invalid query is returned and `lastError()` is not affected.

See also:
  `QSqlQuery`, and `lastError()`.

### hostName

    public final java.lang.String hostName()

  Returns the connection's host name; it may be empty.

See also:
  `setHostName()`.

### isOpen

    public final boolean isOpen()

  Returns true if the database connection is currently open; otherwise returns false.

### isOpenError

    public final boolean isOpenError()

  Returns true if there was an error opening the database connection; otherwise returns false. Error information can be retrieved using the `lastError()` function.

### isValid

    public final boolean isValid()

  Returns true if the `QSqlDatabase` has a valid driver.

  Example:

              QSqlDatabase db = new QSqlDatabase();
              System.out.println(db.isValid());    // Returns false

              db = QSqlDatabase.database("sales");
              System.out.println(db.isValid());    // Returns true if "sales" connection exists

              QSqlDatabase.removeDatabase("sales");
              System.out.println(db.isValid());    // Returns false

### lastError

    public final QSqlError lastError()

  Returns information about the last error that occurred on the database.

  Failures that occur in conjunction with an individual query are reported by `QSqlQuery::lastError()`.

See also:
  `QSqlError`, and `QSqlQuery::lastError()`.

### open

    public final boolean open()

  Opens the database connection using the current connection values. Returns true on success; otherwise returns false. Error information can be retrieved using `lastError()`.

See also:
  `lastError()`, `setDatabaseName()`, `setUserName()`, `setPassword()`, `setHostName()`, `setPort()`, and `setConnectOptions()`.

### open

    public final boolean open(java.lang.String user,
                              java.lang.String password)

  Opens the database connection using the given `user` name and `password`. Returns true on success; otherwise returns false. Error information can be retrieved using the `lastError()` function.

  This function does not store the password it is given. Instead, the password is passed directly to the driver for opening the connection and it is then discarded.

See also:
  `lastError()`.

### password

    public final java.lang.String password()

  Returns the connection's password. If the password was not set with `setPassword()`, and if the password was given in the `open()` call, or if no password was used, an empty string is returned.

See also:
  `setPassword()`.

### port

    public final int port()

  Returns the connection's port number. The value is undefined if the port number has not been set.

See also:
  `setPort()`.

### primaryIndex

    public final QSqlIndex primaryIndex(java.lang.String tablename)

  Returns the primary index for table `tablename`. If no primary index exists an empty `QSqlIndex` is returned.

See also:
  `tables()`, and `record()`.

### record

    public final QSqlRecord record(java.lang.String tablename)

  Returns a `QSqlRecord` populated with the names of all the fields in the table (or view) called `tablename`. The order in which the fields appear in the record is undefined. If no such table (or view) exists, an empty record is returned.

### rollback

    public final boolean rollback()

  Rolls a transaction back on the database if the driver supports transactions and a `transaction()` has been started. Returns true if the operation succeeded; otherwise returns false.

See also:
  `QSqlDriver::hasFeature()`, and `commit()`.

### setConnectOptions

    public final void setConnectOptions()

  Sets database-specific `options`. This must be done before the connection is opened or it has no effect (or you can `close()` the connection, call this function and `open()` the connection again).

  The format of the `options` string is a semicolon separated list of option names or option=value pairs. The options depend on the database client used:

  ODBC | MySQL | `PostgreSQL`
  --- | --- | ---
  `SQL_ATTR_ACCESS_MODE` `SQL_ATTR_LOGIN_TIMEOUT` `SQL_ATTR_CONNECTION_TIMEOUT` `SQL_ATTR_CURRENT_CATALOG` `SQL_ATTR_METADATA_ID` `SQL_ATTR_PACKET_SIZE` `SQL_ATTR_TRACEFILE` `SQL_ATTR_TRACE` `SQL_ATTR_CONNECTION_POOLING` `SQL_ATTR_ODBC_VERSION` | `CLIENT_COMPRESS` `CLIENT_FOUND_ROWS` `CLIENT_IGNORE_SPACE` `CLIENT_SSL` `CLIENT_ODBC` `CLIENT_NO_SCHEMA` `CLIENT_INTERACTIVE` `UNIX_SOCKET` | `connect_timeout` options tty requiressl service
  DB2 | OCI | TDS
  `SQL_ATTR_ACCESS_MODE` `SQL_ATTR_LOGIN_TIMEOUT` | `OCI_ATTR_PREFETCH_ROWS` `OCI_ATTR_PREFETCH_MEMORY` | none
  `SQLite` | Interbase
  `QSQLITE_BUSY_TIMEOUT` | `ISC_DPB_LC_CTYPE` `ISC_DPB_SQL_ROLE_NAME`

  Examples:

          // ...
          // MySQL connection
          db.setConnectOptions("CLIENT_SSL=1;CLIENT_IGNORE_SPACE=1"); // use an SSL connection to the server
          if (!db.open()) {
              db.setConnectOptions(); // clears the connect option string
          // ...
          }
          // ...
          // PostgreSQL connection
          db.setConnectOptions("requiressl=1"); // enable PostgreSQL SSL connections
          if (!db.open()) {
              db.setConnectOptions(); // clear options
              // ...
          }
          // ...
          // ODBC connection
          db.setConnectOptions("SQL_ATTR_ACCESS_MODE=SQL_MODE_READ_ONLY;SQL_ATTR_TRACE=SQL_OPT_TRACE_ON"); // set ODBC options
          if (!db.open()) {
              db.setConnectOptions(); // don't try to set this option
              // ...
          }

  Refer to the client library documentation for more information about the different options.

See also:
  `connectOptions()`.

### setConnectOptions

    public final void setConnectOptions(java.lang.String options)

  Sets database-specific `options`. This must be done before the connection is opened or it has no effect (or you can `close()` the connection, call this function and `open()` the connection again).

  The format of the `options` string is a semicolon separated list of option names or option=value pairs. The options depend on the database client used:

  ODBC | MySQL | `PostgreSQL`
  --- | --- | ---
  `SQL_ATTR_ACCESS_MODE` `SQL_ATTR_LOGIN_TIMEOUT` `SQL_ATTR_CONNECTION_TIMEOUT` `SQL_ATTR_CURRENT_CATALOG` `SQL_ATTR_METADATA_ID` `SQL_ATTR_PACKET_SIZE` `SQL_ATTR_TRACEFILE` `SQL_ATTR_TRACE` `SQL_ATTR_CONNECTION_POOLING` `SQL_ATTR_ODBC_VERSION` | `CLIENT_COMPRESS` `CLIENT_FOUND_ROWS` `CLIENT_IGNORE_SPACE` `CLIENT_SSL` `CLIENT_ODBC` `CLIENT_NO_SCHEMA` `CLIENT_INTERACTIVE` `UNIX_SOCKET` | `connect_timeout` options tty requiressl service
  DB2 | OCI | TDS
  `SQL_ATTR_ACCESS_MODE` `SQL_ATTR_LOGIN_TIMEOUT` | `OCI_ATTR_PREFETCH_ROWS` `OCI_ATTR_PREFETCH_MEMORY` | none
  `SQLite` | Interbase
  `QSQLITE_BUSY_TIMEOUT` | `ISC_DPB_LC_CTYPE` `ISC_DPB_SQL_ROLE_NAME`

  Examples:

          // ...
          // MySQL connection
          db.setConnectOptions("CLIENT_SSL=1;CLIENT_IGNORE_SPACE=1"); // use an SSL connection to the server
          if (!db.open()) {
              db.setConnectOptions(); // clears the connect option string
          // ...
          }
          // ...
          // PostgreSQL connection
          db.setConnectOptions("requiressl=1"); // enable PostgreSQL SSL connections
          if (!db.open()) {
              db.setConnectOptions(); // clear options
              // ...
          }
          // ...
          // ODBC connection
          db.setConnectOptions("SQL_ATTR_ACCESS_MODE=SQL_MODE_READ_ONLY;SQL_ATTR_TRACE=SQL_OPT_TRACE_ON"); // set ODBC options
          if (!db.open()) {
              db.setConnectOptions(); // don't try to set this option
              // ...
          }

  Refer to the client library documentation for more information about the different options.

See also:
  `connectOptions()`.

### setDatabaseName

    public final void setDatabaseName(java.lang.String name)

  Sets the connection's name to `name`. This must be done before the connection is opened or it has no effect; (or you can `close()` the connection, call this function and `open()` the connection again). The name is database-specific.

  For the QOCI (Oracle) driver, the database name is the TNS Service Name.

  For the QODBC driver, the `name` can either be a DSN, a DSN filename (in which case the file must have a `.dsn` extension), or a connection string.

  For example, Microsoft Access users can use the following connection string to open an `.mdb` file directly, instead of having to create a DSN entry in the ODBC manager:

          // ...
          db = QSqlDatabase.addDatabase("QODBC");
          db.setDatabaseName("DRIVER={Microsoft Access Driver (*.mdb)};FIL={MS Access};DBQ=myaccessfile.mdb");
          if (db.open()) {
              // success!
          }
          // ...

  There is no default value.

See also:
  `databaseName()`, `setUserName()`, `setPassword()`, `setHostName()`, `setPort()`, `setConnectOptions()`, and `open()`.

### setHostName

    public final void setHostName(java.lang.String host)

  Sets the connection's host name to `host`. This must be done before the connection is opened or it has no effect (or you can `close()` the connection, call this function and `open()` the connection again).

  There is no default value.

See also:
  `hostName()`, `setUserName()`, `setPassword()`, `setDatabaseName()`, `setPort()`, `setConnectOptions()`, and `open()`.

### setPassword

    public final void setPassword(java.lang.String password)

  Sets the connection's password to `password`. This must be done before the connection is opened or it has no effect (or you can `close()` the connection, call this function and `open()` the connection again).

  There is no default value.

  Warning: This function stores the password in plain text within Qt. Use the `open()` call that takes a password as parameter to avoid this behavior.

See also:
  `password()`, `setUserName()`, `setDatabaseName()`, `setHostName()`, `setPort()`, `setConnectOptions()`, and `open()`.

### setPort

    public final void setPort(int p)

  Sets the connection's port number to `port`. This must be done before the connection is opened or it has no effect (or you can `close()` the connection, call this function and `open()` the connection again).

  There is no default value.

  `setDatabaseName()``setConnectOptions()``open()`

See also:
  `port()`, `setUserName()`, `setPassword()`, and `setHostName()`.

### setUserName

    public final void setUserName(java.lang.String name)

  Sets the connection's user name to `name`. This must be done before the connection is opened or it has no effect (or you can `close()` the connection, call this function and `open()` the connection again).

  There is no default value.

  `setPort()``setConnectOptions()``open()`

See also:
  `userName()`, `setDatabaseName()`, `setPassword()`, and `setHostName()`.

### tables

    public final java.util.List tables()

  This is an overloaded method provided for convenience.

### tables

    public final java.util.List tables(QSql.TableType type)

  Returns a list of the database's tables, system tables and views, as specified by the parameter `type`.

See also:
  `primaryIndex()`, and `record()`.

### transaction

    public final boolean transaction()

  Begins a transaction on the database if the driver supports transactions. Returns true if the operation succeeded; otherwise returns false.

See also:
  `QSqlDriver::hasFeature()`, `commit()`, and `rollback()`.

### userName

    public final java.lang.String userName()

  Returns the connection's user name; it may be empty.

See also:
  `setUserName()`.

### addDatabase

    public static QSqlDatabase addDatabase(QSqlDriver driver)

  This function is useful if you need to set up the database connection and instantiate the driver yourself. If you do this, it is recommended that you include the driver code in your own application. For example, setting up a custom PostgreSQL connection and instantiating the QPSQL driver can be done like this:

              #include "qtdir/src/sql/drivers/psql/qsql_psql.cpp"

  (We assume that `qtdir` is the directory where Qt is installed.) This will pull in the code that is needed to use the PostgreSQL client library and to instantiate a QPSQLDriver object, assuming that you have the PostgreSQL headers somewhere in your include search path.

          PGconn on = PQconnectdb("host=server user=bart password=simpson dbname=springfield");
              QPSQLDriver rv =  new QPSQLDriver(con);
              QSqlDatabase db = QSqlDatabase.addDatabase(drv); // becomes the new default connection
              QSqlQuery query;
              query.exec("SELECT NAME, ID FROM STAFF");
              // ...

  The above code sets up a PostgreSQL connection and instantiates a QPSQLDriver object. Next, `addDatabase()` is called to add the connection to the known connections so that it can be used by the Qt SQL classes. When a driver is instantiated with a connection handle (or set of handles), Qt assumes that you have already opened the database connection.

  Remember that you must link your application against the database client library as well. The simplest way to do this is to add lines like the ones below to your `.pro` file:

               unix:LIBS += -lpq
           win32:LIBS += libpqdll.lib

  You will need to have the client library in your linker's search path.

  The method described above will work for all the drivers, the only difference is the arguments the driver constructors take. Below is an overview of the drivers and their constructor arguments.

  Driver | Class name | Constructor arguments | File to include
  --- | --- | --- | ---
  QPSQL | QPSQLDriver | PGconn *connection | `qsql_psql.cpp`
  QMYSQL | QMYSQLDriver | MYSQL *connection | `qsql_mysql.cpp`
  QOCI | QOCIDriver | OCIEnv *environment, OCISvcCtx *serviceContext | `qsql_oci.cpp`
  QODBC | QODBCDriver | SQLHANDLE environment, SQLHANDLE connection | `qsql_odbc.cpp`
  QDB2 | QDB2 | SQLHANDLE environment, SQLHANDLE connection | `qsql_db2.cpp`
  QTDS | QTDSDriver | LOGINREC *loginRecord, DBPROCESS *dbProcess, const QString &hostName | `qsql_tds.cpp`
  QSQLITE | QSQLiteDriver | sqlite *connection | `qsql_sqlite.cpp`
  QIBASE | QIBaseDriver | isc_db_handle connection | `qsql_ibase.cpp`

  The host name (or service name) is needed when constructing the QTDSDriver for creating new connections for internal queries. This is to prevent the simultaneous usage of several `QSqlQuery` objects from blocking each other.

  Warning: If you add a database with the same name as an existing database, the new database will replace the old one.

  Warning: The SQL framework takes ownership of the `driver` pointer, and it should not be deleted. If you want to explicitly remove the connection, use `removeDatabase()`.

See also:
  `drivers()`.

### addDatabase

    public static QSqlDatabase addDatabase(QSqlDriver driver,
                                           java.lang.String connectionName)

  This function is useful if you need to set up the database connection and instantiate the driver yourself. If you do this, it is recommended that you include the driver code in your own application. For example, setting up a custom PostgreSQL connection and instantiating the QPSQL driver can be done like this:

              #include "qtdir/src/sql/drivers/psql/qsql_psql.cpp"

  (We assume that `qtdir` is the directory where Qt is installed.) This will pull in the code that is needed to use the PostgreSQL client library and to instantiate a QPSQLDriver object, assuming that you have the PostgreSQL headers somewhere in your include search path.

          PGconn on = PQconnectdb("host=server user=bart password=simpson dbname=springfield");
              QPSQLDriver rv =  new QPSQLDriver(con);
              QSqlDatabase db = QSqlDatabase.addDatabase(drv); // becomes the new default connection
              QSqlQuery query;
              query.exec("SELECT NAME, ID FROM STAFF");
              // ...

  The above code sets up a PostgreSQL connection and instantiates a QPSQLDriver object. Next, `addDatabase()` is called to add the connection to the known connections so that it can be used by the Qt SQL classes. When a driver is instantiated with a connection handle (or set of handles), Qt assumes that you have already opened the database connection.

  Remember that you must link your application against the database client library as well. The simplest way to do this is to add lines like the ones below to your `.pro` file:

               unix:LIBS += -lpq
           win32:LIBS += libpqdll.lib

  You will need to have the client library in your linker's search path.

  The method described above will work for all the drivers, the only difference is the arguments the driver constructors take. Below is an overview of the drivers and their constructor arguments.

  Driver | Class name | Constructor arguments | File to include
  --- | --- | --- | ---
  QPSQL | QPSQLDriver | PGconn *connection | `qsql_psql.cpp`
  QMYSQL | QMYSQLDriver | MYSQL *connection | `qsql_mysql.cpp`
  QOCI | QOCIDriver | OCIEnv *environment, OCISvcCtx *serviceContext | `qsql_oci.cpp`
  QODBC | QODBCDriver | SQLHANDLE environment, SQLHANDLE connection | `qsql_odbc.cpp`
  QDB2 | QDB2 | SQLHANDLE environment, SQLHANDLE connection | `qsql_db2.cpp`
  QTDS | QTDSDriver | LOGINREC *loginRecord, DBPROCESS *dbProcess, const QString &hostName | `qsql_tds.cpp`
  QSQLITE | QSQLiteDriver | sqlite *connection | `qsql_sqlite.cpp`
  QIBASE | QIBaseDriver | isc_db_handle connection | `qsql_ibase.cpp`

  The host name (or service name) is needed when constructing the QTDSDriver for creating new connections for internal queries. This is to prevent the simultaneous usage of several `QSqlQuery` objects from blocking each other.

  Warning: If you add a database with the same name as an existing database, the new database will replace the old one.

  Warning: The SQL framework takes ownership of the `driver` pointer, and it should not be deleted. If you want to explicitly remove the connection, use `removeDatabase()`.

See also:
  `drivers()`.

### addDatabase

    public static QSqlDatabase addDatabase(java.lang.String type)

  Adds a database to the list of database connections using the driver `type` and the connection name `connectionName`. If there already exists a database connection called `connectionName`, that connection is removed.

  The database connection is referred to by `connectionName`. The newly added database connection is returned.

  If `connectionName` is not specified, the newly added database connection becomes the default database connection for the application, and subsequent calls to `database()` without a database name parameter will return a reference to it. If `connectionName` is given, use database(`connectionName`) to retrieve a pointer to the database connection.

  Warning: If you add a database with the same name as an existing database, the new database will replace the old one. This will happen automatically if you call this function more than once without specifying `connectionName`.

  To make use of the connection, you will need to set it up, for example by calling some or all of `setDatabaseName()`, `setUserName()`, `setPassword()`, `setHostName()`, `setPort()`, and `setConnectOptions()`, and then you'll need to `open()` the connection.

See also:
  `database()`, `removeDatabase()`, and Threads and the SQL Module.

### addDatabase

    public static QSqlDatabase addDatabase(java.lang.String type,
                                           java.lang.String connectionName)

  Adds a database to the list of database connections using the driver `type` and the connection name `connectionName`. If there already exists a database connection called `connectionName`, that connection is removed.

  The database connection is referred to by `connectionName`. The newly added database connection is returned.

  If `connectionName` is not specified, the newly added database connection becomes the default database connection for the application, and subsequent calls to `database()` without a database name parameter will return a reference to it. If `connectionName` is given, use database(`connectionName`) to retrieve a pointer to the database connection.

  Warning: If you add a database with the same name as an existing database, the new database will replace the old one. This will happen automatically if you call this function more than once without specifying `connectionName`.

  To make use of the connection, you will need to set it up, for example by calling some or all of `setDatabaseName()`, `setUserName()`, `setPassword()`, `setHostName()`, `setPort()`, and `setConnectOptions()`, and then you'll need to `open()` the connection.

See also:
  `database()`, `removeDatabase()`, and Threads and the SQL Module.

### cloneDatabase

    public static QSqlDatabase cloneDatabase(QSqlDatabase other,
                                             java.lang.String connectionName)

  Clones the database connection `other` and and stores it as `connectionName`. All the settings from the original database, e.g. `databaseName()`, `hostName()`, etc., are copied across. Does nothing if `other` is an invalid database. Returns the newly created database connection.

  Note that the connection is not opened, to use it, it is necessary to call `open()` first.

### connectionNames

    public static java.util.List connectionNames()

  Returns a list containing the names of all connections.

See also:
  `contains()`, `database()`, and Threads and the SQL Module.

### contains

    public static boolean contains()

  Returns true if the list of database connections contains `connectionName`; otherwise returns false.

See also:
  `connectionNames()`, `database()`, and Threads and the SQL Module.

### contains

    public static boolean contains(java.lang.String connectionName)

  Returns true if the list of database connections contains `connectionName`; otherwise returns false.

See also:
  `connectionNames()`, `database()`, and Threads and the SQL Module.

### database

    public static QSqlDatabase database(java.lang.String connectionName)

  Returns the database connection called `connectionName`. The database connection must have been previously added with `addDatabase()`. If `open` is true (the default) and the database connection is not already open it is opened now. If no `connectionName` is specified the default connection is used. If `connectionName` does not exist in the list of databases, an invalid connection is returned.

See also:
  `isOpen()`, and Threads and the SQL Module.

### database

    public static QSqlDatabase database()

  Returns the database connection called `connectionName`. The database connection must have been previously added with `addDatabase()`. If `open` is true (the default) and the database connection is not already open it is opened now. If no `connectionName` is specified the default connection is used. If `connectionName` does not exist in the list of databases, an invalid connection is returned.

See also:
  `isOpen()`, and Threads and the SQL Module.

### database

    public static QSqlDatabase database(java.lang.String connectionName,
                                        boolean open)

  Returns the database connection called `connectionName`. The database connection must have been previously added with `addDatabase()`. If `open` is true (the default) and the database connection is not already open it is opened now. If no `connectionName` is specified the default connection is used. If `connectionName` does not exist in the list of databases, an invalid connection is returned.

See also:
  `isOpen()`, and Threads and the SQL Module.

### drivers

    public static java.util.List drivers()

  Returns a list of all the available database drivers.

See also:
  `registerSqlDriver()`.

### isDriverAvailable

    public static boolean isDriverAvailable(java.lang.String name)

  Returns true if a driver called `name` is available; otherwise returns false.

See also:
  `drivers()`.

### registerSqlDriver

    public static void registerSqlDriver(java.lang.String name,
                                         QSqlDriverCreatorBase creator)

  This function registers a new SQL driver called `name`, within the SQL framework. This is useful if you have a custom SQL driver and don't want to compile it as a plugin.

  Example:

           QSqlDatabase.registerSqlDriver("MYDRIVER",
                                           new QSqlDriverCreator<MyDatabaseDriver>);
           QSqlDatabase db = QSqlDatabase.addDatabase("MYDRIVER");

  `QSqlDatabase` takes ownership of the `creator` pointer, so you mustn't delete it yourself.

See also:
  `drivers()`.

### removeDatabase

    public static void removeDatabase(java.lang.String connectionName)

  Removes the database connection `connectionName` from the list of database connections.

  Warning: There should be no open queries on the database connection when this function is called, otherwise a resource leak will occur.

  Example:

          // WRONG
          QSqlDatabase db = QSqlDatabase.database("sales");
          QSqlQuery query = new QSqlQuery("SELECT NAME, DOB FROM EMPLOYEES", db);
          QSqlDatabase.removeDatabase("sales"); // will output a warning

          // "db" is now a dangling invalid database connection,
          // "query" contains an invalid result set

  The correct way to do it:

          {
              QSqlDatabase db = QSqlDatabase.database("sales");
              QSqlQuery query = new QSqlQuery("SELECT NAME, DOB FROM EMPLOYEES", db);
          }
          // Both "db" and "query" are destroyed because they are out of scope
          QSqlDatabase.removeDatabase("sales"); // correct

  To remove the default connection, which may have been created with a call to `addDatabase()` not specifying a connection name, you can retrieve the default connection name by calling `connectionName()` on the database returned by `database()`. Note that if a default database hasn't been created an invalid database will be returned.

See also:
  `database()`, `connectionName()`, and Threads and the SQL Module.

### fromNativePointer

    public static QSqlDatabase fromNativePointer(QNativePointer nativePointer)

  This method returns the QSqlDatabase instance pointed to by `nativePointer`.

### nativePointerArray

    public static QNativePointer nativePointerArray(QSqlDatabase[] array)

  This function returns a QNativePointer that is pointing to the specified QSqlDatabase array.

### defaultConnection

    public static java.lang.String defaultConnection()

  Returns this QSqlDatabase's default connection.

### toString

    public java.lang.String toString()

  Returns a string representation of the `this QSqlDatabase`.

  Overrides:
    `toString` in class `java.lang.Object`

### clone

    public QSqlDatabase clone()

  This method is reimplemented for internal reasons

  Overrides:
    `clone` in class `java.lang.Object`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD